#!/usr/bin/env python
# -*- coding: iso-8859-1 -*-
## ========================================================================
## PyCoinCoin  -  The Tribune Mouling eXPerience With Python, by Chrisix
## ========================================================================
## Copyright (C) 2002-2004  Christophe Prunneaux
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
## ========================================================================

import sys, os, os.path
from constants import *

def check_python_version():
  """ Vrifie que l'on est bien sous python 2.3 ou mieux (nan pas ruby)
  """
  if sys.hexversion < 0x020300F0:
    print "Daisolai, pycc-%s a besoin de python version 2.3 ou suprieure" % PYCC_VERSION
    print "Votre version actuelle de python est :"
    print sys.version
    sys.exit(1)

def check_options_validity(optargs):
  """ Vrifie que le neun^W^Wl'utilisateur n'a pas mis n'importe quoi
      dans sa ligne de commande
  """
  global pycc_script
  if optargs.log_level is not None and optargs.log_level not in range(5):
    print "%s: invalid verbosity level '%d' (should be 0 to 4)" % (pycc_script, optargs.log_level)
    sys.exit(1)
  if optargs.config_dir is not None:
    (parent, dir) = os.path.split(optargs.config_dir)
    if not parent: parent = os.getcwd()
    if not os.path.exists(parent):
      print "%s: non-existant directory: '%s'" % (pycc_script, parent)
      sys.exit(1)

def get_user_path():
  """ Pour rcuprer le rpertoire personnel de l'utilisateur.
      Si on choue, on tentera avec le rpertoire courant.
  """
  try:
    user_path = os.environ['HOME']
  except KeyError:
    user_path = ""
  try:
    if not os.path.exists(user_path):
      user_path = os.environ['USERPROFILE']
  except KeyError:
    user_path = ""
  if not os.path.exists(user_path):
    user_path = os.getcwd()
  return user_path

def init_tk_root(title):
  """ Renvoie une fentre root (fentre principale) d'appli Tk
  """
  root = Tk()
  root.title(title)
  Pmw.initialise(root)
  if os.name == 'posix':
    defaultFont = Pmw.logicalfont('Helvetica', size=12)
    root.option_add('*Font', defaultFont, 'userDefault')
  return root


## ----------------------------------------
## Sai parti... praugramme principal
## ----------------------------------------

check_python_version()

# Rpertoire de lancement de pycc
pycc_path, pycc_script = os.path.split(sys.argv[0])

# Analyse de la ligne de commande
from optparse import OptionParser
_usage = "%prog [options] [bouchot1 bouchot2...]"
_version = "This is %prog (pyCoinCoin), release " + PYCC_VERSION
parser = OptionParser(usage=_usage, version=_version)
parser.add_option("-v", "--verbosity",  metavar="LEVEL", type="int",    action="store", dest="log_level",  help="Verbosity level (0-4)")
parser.add_option("-c", "--config-dir", metavar="DIR",   type="string", action="store", dest="config_dir", help="Config & options directory")
(optargs, args) = parser.parse_args()
check_options_validity(optargs)
  
# Import de modules ncessaires
from Tkinter import *

# Import de Pmw avec vrification de la version
try:
  import Pmw
except:
  print "Diantre, je ne parviens pas  importer le module Pmw..."
  print "Je parie douze slips neufs contre une cacahute que vous avez oubli de l'installer."
  sys.exit(1)
  
if float(Pmw.version()) < 1.2:
  print "Daisolai, votre version de Pmw sent un peu le moisi"
  print "pycc-%s a besoin de Pmw 1.2 (ou ultrieure)" % PYCC_VERSION
  sys.exit(1)

Pmw.reporterrorstofile(file = sys.stderr)

from coinlib.utils import *

# Construction du logger d'vnements
import logging
log = logging.getLogger('pycc')
add_screen_handler(log)
set_log_level(log, optargs.log_level)

# Message de bienvenue
title = " \_o< ~  pyCoinCoin %s  ~ >o_/" % PYCC_VERSION
print "=" * 40
print title
print "=" * 40

# Rpertoire des fichiers de config xml de pycc
config_path = optargs.config_dir
if config_path is None:
  config_path = os.path.join(get_user_path(), ".pycc08")
log.debug("Rpertoire de config: %s" % config_path)

first_run = not os.path.exists(os.path.join(config_path, "Config.xml"))

if first_run:
  from pyc4.wizards import FirstRunWizard
  log.debug("Config vide, mode premier lancement activ")
  myroot = init_tk_root(title)
  myroot.canceled = 1
  FirstRunWizard(myroot, config_path, pycc_path)
  myroot.mainloop()
  if myroot.canceled:
    sys.exit(0)

# Lancement de la fentre du coincoin
log.info("Initialisation en cours...")
from pyc2 import PyCoinCoin
root = init_tk_root(title)
duck = PyCoinCoin(root, config_path, optargs.log_level, pycc_path, blist=args)
root.mainloop()
