# -*- coding: iso-8859-1 -*-
## ----------------------------------------------------------------------
## PyCoinCoin - Module utils
##   Diverses fonctions utilises un peu partout dans PyCoinCoin.
## ----------------------------------------------------------------------

from os.path import join, isdir, exists, split
import os, urllib2, base64, md5
import sys
sys.path.append('..')
from constants import PYCC_VERSION

import logging
log = logging.getLogger('pycc')

try:
  import winsound
  pf_win = 1
except:
  pf_win = 0

def play_sound(snd_file):
  if pf_win:
    winsound.PlaySound(snd_file, winsound.SND_FILENAME | winsound.SND_NOWAIT)
  else:
    os.system(join(split(sys.argv[0])[0], "playwrapper") + " " + snd_file + " &")
  
import types
_unicode = types.UnicodeType

"""
def unidaube(text):
  try:
    res = text.encode('iso-8859-15')
  except:
    res = text
  return res
"""

def toUnicode(text, encoding='iso-8859-1'):
  if type(text) == _unicode:
    return text
  else:
    try:
      return text.decode(encoding)
    except:
      pass
    log.warning("Chaine unicode pourrite: "+repr(text))
    try:
      return unicode(text, "utf-8")
    except:
      pass
    log.warning("Chaine doublement pourrite")
    return unicode(repr(text), encoding)

def add_screen_handler(log):
  screen_fmt = logging.Formatter('%(asctime)s %(levelname)s [%(module)s]\n    %(message)s')
  hdlr = logging.StreamHandler()
  hdlr.setFormatter(screen_fmt)
  log.addHandler(hdlr)

def set_log_level(log, level):
  if level is None: level = 0
  if type(level) is int:
    _levels = [logging.CRITICAL, logging.ERROR, logging.WARNING, logging.INFO, logging.DEBUG]
    log.setLevel(_levels[level])
  else:
    log.setLevel(eval("logging."+level))

def get_available_bouchots(config_path):
  path = join(config_path, "bouchots")
  try:
    if exists(path):
      return [ file for file in os.listdir(path) if isdir(join(path, file)) ]
    else:
      log.error("Eeuuuh, le rpertoire '%s' n'existe pas, on va pas aller loin" % path)
      return []
  except:
    log.exception("Y'a eu vautrage pendant get_available_bouchots")

def get_modules(config_path, bouchal):
  path = join(config_path, "bouchots", bouchal)
  return [ file for file in os.listdir(path) if isdir(join(path, file)) ]

def escape_spec_chars(text, hash):
  res = toUnicode(text)
  res = res.replace("%%", "{#percent#}")
  for spec, repl in hash.items():
    res = res.replace(spec, repl)
  return res.replace("{#percent#}", "%")

def get_spec_hash(post, bouchot):
  hash = {}
  hash["%i"] = "%s"%post.id
  hash["%l"] = post.login
  hash["%u"] = post.info
  hash["%h"] = post.dispTimeRef()
  hash["%d"] = post.disp('date')
  hash["%m"] = post.message
  orig_txt = toUnicode(post.original_text, bouchot.trib.options.val('encoding'))
  orig_txt = orig_txt.replace(ur'', '<') # Restauration des vrais < et >
  orig_txt = orig_txt.replace(ur'', '>') # (bidouille cradoc)
  hash["%o"] = orig_txt
  hash["%f"] = ", ".join(post.status)
  if hasattr(post, 'ctxt_keyword'):
    hash["%w"] = post.ctxt_keyword
  hash["%t"] = bouchot.name
  hash["%c"] = bouchot.pycc.clipboard
  return hash

def execute_cmd(cmdline):
    arglist = []
    start = cmdline.find("\"")
    cursor = 0
    while start >= 0:
      end = cmdline.find("\"", start+1)
      if end < start: break
      arglist += cmdline[cursor:start].split()
      arglist.append(cmdline[start+1:end])
      cursor = end+1
      start = cmdline.find("\"", cursor)
    arglist += cmdline[cursor:].split()
    log.info("Commande systme: %s" % str(arglist))
    try:
      if os.name == 'posix':
        apply(os.spawnl, [os.P_NOWAIT, arglist[0]]+arglist)
      else:
        apply(os.spawnl, [os.P_NOWAIT, arglist[0]]+['"%s"' % arg for arg in arglist])
      return 1
    except OSError, value:
      log.error("Echec de la commande: %s\n    %s" % (cmdline, value))
      return 0

class _UrlOpener:
  instance = None
  def __init__(self, proxy):
    log.info("Chargement de l'UrlOpener pour passage par proxy")
    proxy_handler = urllib2.ProxyHandler({'http': proxy})
    opener = urllib2.build_opener(proxy_handler)
    urllib2.install_opener(opener)

def UrlOpener(proxy):
  if _UrlOpener.instance == None:
    _UrlOpener.instance = _UrlOpener(proxy)
  return _UrlOpener.instance

def save_url(url, config, config_path):
  log.info("Sauvegarde URL: %s" % url)
  proxy = config.val('http_proxy')
  if proxy:
    UrlOpener(proxy)
  """
    log.debug("Passage par proxy")
    proxy_handler = urllib2.ProxyHandler({'http': proxy})
    opener = urllib2.build_opener(proxy_handler)
    urllib2.install_opener(opener)
  """
  #else:
  #  urllib2.install_opener()
  request = urllib2.Request(url)
  user_passwd = config.val('http_proxy_auth')
  if proxy and user_passwd:
    log.debug("Proxy avec auth. basic")
    parm = base64.encodestring(user_passwd)
    request.add_header('Proxy-Authorization', 'Basic %s' % parm[:-1])
  ua = "pyCoinCoin/%s" % PYCC_VERSION
  log.debug("User-Agent '%s'" % ua)
  request.add_header('User-Agent', ua)
  request.add_header('Pragma', 'no-cache')
  rf = urllib2.urlopen(request)
  data = rf.read()
  rf.close()
  save_path = join(config_path, "cache")
  if not exists(save_path):
    os.mkdir(save_path)
  target = join(save_path, md5.new(url).hexdigest())
  try:
    f = open(target,'wb')
    f.write(data)
    f.close()
  except:
    log.error("Erreur lors de la tentative de sauvegarde de:\n%s vers %s" % (url, target))

def open_url(server, url, config, ua='', cookie='', data=None, headers={}):
  log.info("Ouverture URL: http://%s%s" % (server, url))
  proxy = config.val('http_proxy')
  if proxy:
    UrlOpener(proxy)
  """
    log.debug("Passage par proxy")
    proxy_handler = urllib2.ProxyHandler({'http': proxy})
    opener = urllib2.build_opener(proxy_handler)
    urllib2.install_opener(opener)
  """
  #else:
  #  urllib2.install_opener()
  request = urllib2.Request("http://"+server+url)
  user_passwd = config.val('http_proxy_auth')
  if proxy and user_passwd:
    # request.set_proxy("gnetcache.alcatel.fr:3128", "http") # ESSAI
    log.debug("Proxy avec auth. basic")
    parm = base64.encodestring(user_passwd)
    request.add_header('Proxy-Authorization', 'Basic %s' % parm[:-1])
  if not (ua or data):
    ua = "pyCoinCoin/%s" % PYCC_VERSION
  log.debug("User-Agent '%s'" % ua)
  request.add_header('User-Agent', ua)
  request.add_header('Pragma', 'no-cache')
  for head, val in headers.items():
    log.debug("Ajout header HTTP: %s=%s" % (head, val))
    request.add_header(head, val)
  if cookie:
    log.debug("Ajout cookie HTTP: %s", cookie)
    request.add_header('Cookie', cookie)
  if config.val('http_referer'):
    request.add_header('Referer', 'http://'+server+'/')
  if data is not None:
    log.debug("Ajout donnes: %s", data)
    request.add_data(data)
  return urllib2.urlopen(request)
  

def open_url_tmp(server, url, config, ua='', cookie='', data=None, headers={}, proxy=None, user_passwd=None):
  log.info("Ouverture URL: %s, %s" % (server, url))
  if proxy:
    log.debug("Passage par proxy")
    proxy_handler = urllib2.ProxyHandler({'http': proxy})
    opener = urllib2.build_opener(proxy_handler)
    urllib2.install_opener(opener)
  #else:
  #  urllib2.install_opener()
  request = urllib2.Request("http://"+server+url)
  user_passwd = config.val('http_proxy_auth')
  if proxy and user_passwd:
    log.debug("Proxy avec auth. basic")
    parm = base64.encodestring(user_passwd)
    request.add_header('Proxy-Authorization', 'Basic %s' % parm[:-1])
  if not (ua or data):
    ua = "pyCoinCoin/%s" % PYCC_VERSION
  log.debug("User-Agent '%s'" % ua)
  request.add_header('User-Agent', ua)
  request.add_header('Pragma', 'no-cache')
  for head, val in headers.items():
    log.debug("Ajout header HTTP: %s=%s" % (head, val))
    request.add_header(head, val)
  if cookie:
    log.debug("Ajout cookie HTTP: %s", cookie)
    request.add_header('Cookie', cookie)
  # if config.val('http_referer'):
  #   conn.addheaders.append(('Referer', 'http://'+server+'/'))
  if data is not None:
    log.debug("Ajout donnes: %s", data)
    request.add_data(data)
  return urllib2.urlopen(request)


try:
  import Image, ImageTk
  use_pil = 1
except:
  from Tkinter import PhotoImage
  use_pil = 0

def get_image(filename):
  if use_pil:
    im = Image.open(filename)
    return ImageTk.PhotoImage(im)
  else:
    return PhotoImage(file=filename)


def apply_styles(widget, styleset, mode='pinni', defaults=None):
  """ Pour appliquer les styles dfinis dans le styleset au widget donn
      - styleset doit tre de type StyleSet ou driv (Theme, etc.)
      - widget doit tre de type Text ou driv
      - mode peut tre 'pinni', 'palmi' ou 'popup'
  """
  for name, style in styleset.get().items():
    if defaults is not None and style.use_default:
      try:
        # On tente d'obtenir le style par dfaut de mme nom
        style = defaults.get(name)
      except:  # Le style par dfaut n'est pas dfini
        pass   # On garde le style original
    try:
      if name == 'base':
        eval("widget.config(%s)" % style.get())
        basefont = style.get('font')
        forecolor = style.get('foreground')
        if mode == 'popup':
          eval("widget.config(%s)" % styleset.get('hilight').get())
      else:
        bufidx = widget.tag_ranges(name)
        widget.tag_delete(name)
        eval("widget.tag_config('%s', %s)" % (name, style.get()))
        for cpt in range(0, len(bufidx), 2):
          widget.tag_add(name, bufidx[cpt], bufidx[cpt+1])
    except:
      log.warning("apply_styles: Gne gna du mal avec le style '%s'" % name)
  try:
    widget.tag_config("b",  font=(basefont[0], basefont[1], 'bold'))
    widget.tag_config("i",  font=(basefont[0], basefont[1], 'italic'))
    widget.tag_config("bi", font=(basefont[0], basefont[1], 'bold italic'))
    widget.config(selectforeground=forecolor)
  except:
    log.warning("apply_styles: Bigre, je ne parviens pas  configurer la police du style de base")
  widget.tag_config("u", underline=1)
  widget.tag_config("s", overstrike=1)
  sort_tags(widget, mode)
  
def sort_tags(widget, mode='pinni'):
  """ Pour trier les tags de style dans le bon ordre
      - widget doit tre de type Text ou driv
      - mode peut tre 'pinni', 'palmi' ou 'popup'
  """
  if mode == 'palmi':
    sorted_tags = []
  else:
    sorted_tags = ['answer', 'myposts', 'hilight', 'login', 'info', 'time', 'tt', 'a', 'clock', 'crossclock', 'urlvisit', 'hilightref', 'urlhilight', 'hilifound']
  for tag in sorted_tags:
    try:
      widget.tag_raise(tag)
    except:
      pass
