# -*- coding: iso-8859-1 -*-
## ----------------------------------------------------------------------
## PyCoinCoin - Plug-in ReferenceDumper
## ----------------------------------------------------------------------

import logging
log = logging.getLogger('pycc')
import sys
sys.path.append('..')
from coinlib.plugin import *
import types

from time import *
import os.path

def build_plugins(pycc):
  return { \
    'rd': ReferenceDumper(pycc, "Reference dumper", "Retourne les 20 objets dont il y a le plus d'instances")
  }

class ReferenceDumper(Plugin):

  def action_menu(self):
    self.process(self.pycc.bouchots[self.pycc.get_bouchot()])

  def process(self, bouchot, context=PINNI, post=None):
    self.print_top_20()

  def get_refcounts(self):
    d = {}
    sys.modules
    # collect all classes
    for m in sys.modules.values():
        for sym in dir(m):
            o = getattr (m, sym)
            if type(o) is types.ClassType:
                d[o] = sys.getrefcount (o)
    # sort by refcount
    pairs = map (lambda x: (x[1],x[0]), d.items())
    pairs.sort()
    pairs.reverse()
    return pairs

  def print_top_20(self):
    for n, c in self.get_refcounts()[:40]:
        print '%10d %s' % (n, c.__name__)
  